#include "Matrix.h"
#include <cstdlib>

void CreateMatrix( Matrix& M, const int rows, const int cols )
{
    M.width = cols;
    M.height = rows;
    size_t size = M.width * M.height;
    M.elements = new float[ size ];
    M.stride_in_bytes = M.width * sizeof( float );
}


void FillRandomMatrix( Matrix& A )
{
    for ( int i = 0; i < A.width * A.height; i++ )
    {
        A.elements[ i ] = rand() / (float)RAND_MAX;
    }
    
}

void DestroyMatrix( Matrix& mat )
{
    delete [] mat.elements;
    mat.elements = nullptr;
    mat.width = 0;
    mat.height = 0;
    mat.stride_in_bytes = 0;
}

void MatMul_CPU( const Matrix& A, const Matrix& B, Matrix& C )
{
    for ( int i = 0; i < A.height; i++ )
    {
        for ( int j = 0; j < B.width; j++ )
        {
            float sum = 0;
            for ( int k = 0; k < A.width; k++ )
            {
                sum += A.elements[ i * A.width + k ] * B.elements[ k * B.width + j ];
            }
            C.elements[ i * C.width + j ] = sum;
        }
    }
}
